<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
</body>
<script>
    let students = [
        {
            studentID: 1,
            age: 79,
            givenNames: ["John", "Federico"],
            lastName: "Kennedy",
            isGraduated: false,
            registeredCourses: ["Cooking 101", "Aesthetic Programming"]
        },
        {
            studentID: 42,
            age: 666,
            givenNames: ["Pepita"],
            lastName: "Golondrina",
            isGraduated: true,
            registeredCourses: ["Cooking 101", "Aesthetic Programming", "Pottery"]
        },
        {
            studentID: 235768798,
            age: 13,
            givenNames: ["Pablo", "Rodriguez"],
            lastName: "Escobar",
            isGraduated: true,
            registeredCourses: ["Cooking 101", "Aesthetic Programming", "Export/Import"]
        },
    ]

    // Create a function that: 
    // 1 Receives a student and “calculate" their firstName, the firstName is the first given name.

    function calculateFirstName(aSpecificStudent) {
        return aSpecificStudent.givenNames[0]
    }

    console.log("Result of point 1")
    console.log(calculateFirstName({ givenNames: ["John", "Federico"] })) //or (student[0])

    // Create a new function that:
    // 2A Creates a new array that only contains all the studentIDs

    function allTheStudentsIDs() {
        return students.map(transformAStudentIntoAnId)
    }

    function transformAStudentIntoAnId(aStudent) {
        return aStudent.studentID
    }

    console.log("Result of point 2A")
    console.log(allTheStudentsIDs())

    // 2B Creates a new array that only contains all the students that are graduated

    function graduatedStudents() {
        return students.filter(checkIfStudentIsGraduated)
    }

    function checkIfStudentIsGraduated(aStudent) {
        return aStudent.isGraduated
    }

    function transformTheStudentIntoAFirstName(aStudent) {
        return calculateFirstName(aStudent)
    }

    console.log("Result of point 2B")
    console.log(graduatedStudents().map(transformTheStudentIntoAFirstName))

    // 2C Finds out how many students are graduated
    function howManyStudentsAreGraduated() {
        return graduatedStudents().length
    }

    console.log("Result of point 2C")
    console.log(howManyStudentsAreGraduated())

    // 2D Finds out how many unique courses these students are registered to
    function howManyCourses(params) {

    }

    console.log("Result of point 2D")
    console.log(howManyCourses())

    // 2E Removes the student with the studentID: 42
    function removeStudentId42(params) {

    }
    console.log("Result of point 2E")
    console.log(removeStudentId42())

    // 2F Calculates the average age of these students
    function averageAge(params) {

    }
    console.log("Result of point 2F")
    console.log(averageAge())

</script>

</html>